image: ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/python:3.11-slim

stages:
  - build
  - release

variables:
  DOCKER_IMAGE: ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:24.0.5
  CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  CONTAINER_RELEASE_IMAGE: $CI_REGISTRY_IMAGE:latest

docker-build:
  image: $DOCKER_IMAGE
  stage: build
  services:
    - 'docker:dind'
  script:
    - echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER --password-stdin $CI_REGISTRY
    - docker context create builder
    - docker buildx create builder --use
    - docker buildx build --pull --platform linux/amd64,linux/arm64/v8 --provenance false -t $CONTAINER_TEST_IMAGE --push .
  # only:
  #   changes:
  #     - src/**/*
  #     - Dockerfile

release-build:
  image: $DOCKER_IMAGE
  stage: release
  services:
    - 'docker:dind'
  script:
    - echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER --password-stdin $CI_REGISTRY
    - docker pull $CONTAINER_TEST_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE
    - docker push $CONTAINER_RELEASE_IMAGE
  only:
    - master
  needs: ['docker-build']

helm:package:
  stage: build
  image:
    name: ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/alpine/helm:3.5.3
    entrypoint: ['']
  variables:
    CHART_REPOSITORY_NAME: charts
  before_script:
    - apk add git
    - helm plugin install https://github.com/chartmuseum/helm-push
    - >
      helm repo add ${CHART_REPOSITORY_NAME} --username ${CI_REGISTRY_USER} --password ${CI_REGISTRY_PASSWORD} ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/helm/stable


  script:
    - helm cm-push deployment/ ${CHART_REPOSITORY_NAME}
    - echo "You can find your chart index at:"
    - echo ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/helm/stable/index.yaml
  # only:
  #   changes:
  #     - deployment/**/*
